﻿/* ETBdocNav.jsx ====== UTF-8 =====================================================================
   Display a tree view from paragraphs for document navigation
Location      E:\_DDDprojects\FM-toolbar00\AllETB\Scripts\StandAloneVersions\ETBdocNav.jsx
Documents     www.daube.ch/docu/fmaker84.html
Attention     The structural levels are taken from the paragraph tag names by regular expression
              or table in ETBextras.cfg
Reference     Rick Quatro: DocumentNavigator.jsx

Copyleft      2020 Klaus Daube, Zürich, Switzerland, klaus@daube.ch
History       2020-01-24 start of development
              2020-03-02 become sub-function in ETBextra.jsx
              2022-11-09 The ES method for localisation uses the Windows language, not the FM one!
*/ ; // ===========================================================================================

KLD_E.oTree = {};

KLD_E.DocNavUIText = function (FMlang) { // --- Set the UI texts for ETBdocNav --------------------
  if (FMlang == "de") {
    KLD_E.sDnav_title     = "Dokument Navigation ETB";
    KLD_E.sDnav_docRequ   = "Ein aktives Dokument ist notwendig für diese Funktion.";
    KLD_E.sDnav_lvlDefs   = "Keine (gültige) Tabelle ist definiert zur Evaluation der Überschriften-Ebenen";
    KLD_E.sDnav_docDamaged= "Keinen ersten Absatz gefunden. Das Dokument ist offenbar defekt.";
    KLD_E.sDnav_noPgfTab  = "Keine Absätze gefunden, die der Ebenen-Definition in der Tabelle entsprechen.";
    KLD_E.sDnav_hlpTip1   = "Zurück";
    KLD_E.sDnav_bExpand   = "Erweitern";
    KLD_E.sDnav_hlpTip2   = "Alle Zweige erweitern";
    KLD_E.sDnav_bCollapse = "Reduzieren";
    KLD_E.sDnav_hlpTip3   = "Alle Zweige reduzieren";
    KLD_E.sDnav_hlpTip4   = "Zu früherem Ziel zurück gehen";
    KLD_E.sDnav_cbStyle   = "Formatname / Titel";
    KLD_E.sDnav_hlpTip5   = "Option aktivieren, um Formatnamen statt der Titel anzuzeigen → dann Aktualisieren";
    KLD_E.sDnav_bRefresh  = "Aktualisieren";
    KLD_E.sDnav_hlpTip6   = "Titel-Liste aktualisieren";
    KLD_E.sDnav_missing   = "→ Fehlende Ebene";
    KLD_E.sDnav_unused    = "→ Nicht verwendete Ebene";
    KLD_E.sDnav_bDefine   = "Definieren";
    KLD_E.sDnav_hlpTip7   = "Überschriften-Ebenen definieren";
    KLD_E.sDnav_tLevel    = "Ebene";
    KLD_E.sDnav_tExplain  = "Format-Namen durch Strichpunkt getrennt. Keine Leerstelle nach dem Strichpunkt.";
    KLD_E.sDnav_btnSave   = "Speichern";
    KLD_E.sDnav_btnCancel = "Abbrechen";
  } else if (FMlang == "fr") {
    KLD_E.sDnav_title     = "Navigation de document ETB";
    KLD_E.sDnav_docRequ   = "Un document actif est nécessaire pour cette fonction.";
    KLD_E.sDnav_lvlDefs   = "Pas de tableau (correct) défini pour évaluer des niveaux des titres";
    KLD_E.sDnav_docDamaged= "Aucun premier paragraphe valide n'a été trouvé. Le document semble être endommagé.";
    KLD_E.sDnav_noPgfTab  = "Aucun paragraphe trouvé ne correspond à la définition du niveau dans le tableau.";
    KLD_E.sDnav_hlpTip1   = "Revenir en arrière";
    KLD_E.sDnav_bExpand   = "Développer";
    KLD_E.sDnav_hlpTip2   = "Développer tous les nœuds";
    KLD_E.sDnav_bCollapse = "Réduire";
    KLD_E.sDnav_hlpTip3   = "Réduire toutes les branches";
    KLD_E.sDnav_hlpTip4   = "Revenir à l'objectif précédent";
    KLD_E.sDnav_cbStyle   = "Nom du style / Titre";
    KLD_E.sDnav_hlpTip5   = "Réglez cette option pour afficher les noms des balises plutôt que le texte du titre → puis Rafraîchir";
    KLD_E.sDnav_bRefresh  = "Actualiser";
    KLD_E.sDnav_hlpTip6   = "Actualiser la liste des titres";
    KLD_E.sDnav_missing   = "→ Niveau manquant";
    KLD_E.sDnav_unused    = "→ Niveau non utilisé";
    KLD_E.sDnav_bDefine   = "Définir";
    KLD_E.sDnav_hlpTip7   = "Définir les niveaux des titres";
    KLD_E.sDnav_tLevel    = "Niveau";
    KLD_E.sDnav_tExplain  = "Noms de format, séparés par un point-virgule. Pas d'espace après le point-virgule.";
    KLD_E.sDnav_btnSave   = "Enregistrer";
    KLD_E.sDnav_btnCancel = "Annuller";
  } else {
    KLD_E.sDnav_title     = "Document Navigation ETB";
    KLD_E.sDnav_docRequ   = "An acitve document is required for this function.";
    KLD_E.sDnav_lvlDefs   = "No (correct) table defined to evaluate the level of headings";
    KLD_E.sDnav_docDamaged="No valid first paragraph found. Document seems to be damaged.";
    KLD_E.sDnav_noPgfTab  = "No paragraphs found according to the level-table";
    KLD_E.sDnav_hlpTip1   = "Go back";
    KLD_E.sDnav_bExpand   = "Expand";
    KLD_E.sDnav_hlpTip2   = "Expand all nodes";
    KLD_E.sDnav_bCollapse = "Collapse";
    KLD_E.sDnav_hlpTip3   = "Collapse all branches";
    KLD_E.sDnav_hlpTip4   = "Go back to previous target";
    KLD_E.sDnav_cbStyle   = "Style name / Title";
    KLD_E.sDnav_hlpTip5   = "Set this option to display Tag names rather than Title text → then Refresh";
    KLD_E.sDnav_bRefresh  = "Refresh";
    KLD_E.sDnav_hlpTip6   = "Refresh the palette";
    KLD_E.sDnav_missing   = "→ Missing level";
    KLD_E.sDnav_unused    = "→ Unused level";
    KLD_E.sDnav_bDefine   = "Define";
    KLD_E.sDnav_hlpTip7   = "Define the heading levels";
    KLD_E.sDnav_tLevel    = "Level";
    KLD_E.sDnav_tExplain  = "Format names; separated by semicolon. No space after the semicolon.";
    KLD_E.sDnav_btnSave   = "Save";
    KLD_E.sDnav_btnCancel = "Cancel";
  }
} // --- end DocNavUIText -------------------------------------------------------------------------

KLD_E.DefineLevels = function () { // =============================================================
var wDefine, sLevel0, sLevel1, sLevel2, sLevel3;

  wDefine = new Window ("dialog", KLD_E.sDnav_hlpTip7, undefined);
  wDefine.preferredSize.width = 500;
  wDefine.alignChildren = ["left","top"];
  wDefine.spacing = 10;
  wDefine.margins = 5;
  wDefine.p1 = wDefine.add("panel", undefined, undefined);
  wDefine.p1.orientation = "column";
  wDefine.p1.alignChildren = ["left","top"];

  wDefine.p1.gt = wDefine.p1.add("group", undefined, undefined);
  wDefine.p1.gt.stx = wDefine.p1.gt.add("statictext", undefined, KLD_E.sDnav_tLevel);
  wDefine.p1.gt.sty = wDefine.p1.gt.add("statictext", undefined, KLD_E.sDnav_tExplain);

  wDefine.p1.g0 = wDefine.p1.add("group", undefined, undefined);
  wDefine.p1.g0.st0 = wDefine.p1.g0.add("statictext", undefined, "0");
  wDefine.p1.g0.e0 = wDefine.p1.g0.add("edittext" , undefined, "level_0-format");
  wDefine.p1.g0.e0.graphics.font = ScriptUI.newFont ("Consolas", "", 11);
  wDefine.p1.g0.e0.preferredSize.width = 450;

  wDefine.p1.g1 = wDefine.p1.add("group", undefined, undefined);
  wDefine.p1.g1.st0 = wDefine.p1.g1.add("statictext", undefined, "1");
  wDefine.p1.g1.e0 = wDefine.p1.g1.add("edittext" , undefined, "level_1-format");
  wDefine.p1.g1.e0.graphics.font = ScriptUI.newFont ("Consolas", "", 11);
  wDefine.p1.g1.e0.preferredSize.width = 450;

  wDefine.p1.g2 = wDefine.p1.add("group", undefined, undefined);
  wDefine.p1.g2.st0 = wDefine.p1.g2.add("statictext", undefined, "2");
  wDefine.p1.g2.e0 = wDefine.p1.g2.add("edittext" , undefined, "level_2-format");
  wDefine.p1.g2.e0.graphics.font = ScriptUI.newFont ("Consolas", "", 11);
  wDefine.p1.g2.e0.preferredSize.width = 450;

  wDefine.p1.g3 = wDefine.p1.add("group", undefined, undefined);
  wDefine.p1.g3.st0 = wDefine.p1.g3.add("statictext", undefined, "3");
  wDefine.p1.g3.e0 = wDefine.p1.g3.add("edittext" , undefined, "level_3-format");
  wDefine.p1.g3.e0.graphics.font = ScriptUI.newFont ("Consolas", "", 11);
  wDefine.p1.g3.e0.preferredSize.width = 450;
// --- button group ------------------------------
  wDefine.p1.gb = wDefine.p1.add("group", undefined, undefined);
  wDefine.p1.gb.alignChildren = ["left","top"];
  wDefine.p1.gb.btnSave = wDefine.p1.gb.add("button", undefined, KLD_E.sDnav_btnSave);
  wDefine.p1.gb.spacer  = wDefine.p1.gb.add("statictext", undefined, "   ");
  wDefine.p1.gb.spacer.preferredSize.width = 285;
  wDefine.p1.gb.btnCancel = wDefine.p1.gb.add("button", undefined, KLD_E.sDnav_btnCancel);
// --- behaviour of the edit fields --------------
  sLevel0 = KLD_E.GetIniValue (KLD_E.sExtrasCfg, "0", "level-0-formats");
  wDefine.p1.g0.e0.text = sLevel0;
  sLevel1 = KLD_E.GetIniValue (KLD_E.sExtrasCfg, "1", "level-1-formats");
  wDefine.p1.g1.e0.text = sLevel1;
  sLevel2 = KLD_E.GetIniValue (KLD_E.sExtrasCfg, "2", "level-2-formats");
  wDefine.p1.g2.e0.text = sLevel2;
  sLevel3 = KLD_E.GetIniValue (KLD_E.sExtrasCfg, "3", "level-3-formats");
  wDefine.p1.g3.e0.text = sLevel3;
// --- behaviour of the buttons ------------------
  wDefine.p1.gb.btnSave.onClick = function () {
    if (sLevel0 != wDefine.p1.g0.e0.text) {
      KLD_E.PutIniValue (KLD_E.sExtrasCfg, "0", wDefine.p1.g0.e0.text);
    }
    if (sLevel1 != wDefine.p1.g1.e0.text) {
      KLD_E.PutIniValue (KLD_E.sExtrasCfg, "1", wDefine.p1.g1.e0.text);
    }
    if (sLevel2 != wDefine.p1.g2.e0.text) {
      KLD_E.PutIniValue (KLD_E.sExtrasCfg, "2", wDefine.p1.g2.e0.text);
    }
    if (sLevel3 != wDefine.p1.g3.e0.text) {
      KLD_E.PutIniValue (KLD_E.sExtrasCfg, "3", wDefine.p1.g3.e0.text);
    }
    wDefine.close();
    return;
  }
  wDefine.p1.gb.btnCancel.onClick = function () {
    wDefine.close();
  }
// --- final tasks -------------------------------
  wDefine.show();
} // --- end DefineLevels -------------------------------------------------------------------------

KLD_E.CnvCtrlToSpace = function (sText) { // ======================================================
/*            Convet control characters (\x00 … \x1f) to space (\x20)
Arguments     sText           String to be converted
Returns       Converted string
Called by     BuildTree
Used in       ETBdocNav
History       2022-09-27
*/
var j, sConv = sText, len = sConv.length, kChar, sChar ;

  for(j = 0; j < len; j++) {
    kChar = sConv.charCodeAt (j)                  // 000D
    if (kChar < 32) {
      sConv = sConv.substring(0, j) + " " + sConv.substring(j+1);
    }
  }
  return sConv;
} // --- end CnvCtrlToSpace -----------------------------------------------------------------------

KLD_E.DocNav  = function (location, bTag)  { // === Main function =================================
// Arguments  location       Current screen location of palette. used for resize
//            bTag           true for presentation of tag name, false for title text
// Called by  -
// Calling    KLD_E.BuildPalette, KLD_E.GetParagraphs
// Comment    To be implemented in ETBdocNav

var aPgfs = [], oDoc, wDocNav;

  if (bTag === undefined) {bTag = false};
  oDoc = app.ActiveDoc;
  if (!oDoc.ObjectValid()) {
    alert (KLD_E.sDnav_docRequ, KLD_E.sDnav_title, true);
    return;
  }
  if (!oDoc.MainFlowInDoc.FirstTextFrameInFlow.FirstPgf.ObjectValid()) {
    alert (KLD_E.sDnav_docDamaged, KLD_E.sDnav_title, true);
    return;
  }
  KLD_E.GetLevelSettings ();
  KLD_E.GetParagraphs (oDoc, aPgfs, KLD_E.sFormats);
  if (aPgfs.length == 0) {
    alert (KLD_E.sDnav_noPgfTab, KLD_E.sDnav_title, true);
    KLD_E.DefineLevels ();                        // allow user to correct the table.
    return;
  };
  wDocNav = KLD_E.BuildPalette (oDoc, aPgfs, KLD_E.sFormats, bTag);
  if (location) {
    wDocNav.bounds = location;  // Restore the palette's previous size and location on the screen.
  }
} // end of DocNav --------------------------------------------------------------------------------

KLD_E.BtnDefine = function () { // === Define heading level in cfg file ===========================
// Returns    modified ETBextras.cfg file
// Called by  KLD_E.BuildPalette

  KLD_E.DefineLevels ();
} // end of BtnDefine -----------------------------------------------------------------------------

KLD_E.BtnExpand = function (oTree) { // === Expand tree - used recursively ========================
// Arguments  oTree          TreeView object to be handled
// Returns    Modified oTree
// Called by  KLD_E.BuildPalette
// Reference  Peter Kharel: ScriptUI for dummies https://creativepro.com/files/kahrel/indesign/scriptui.html
var j, branches;
  oTree.expanded = true;
  branches = oTree.items;
  for (var j = 0; j < branches.length; j++) {
    if (branches[j].type == 'node') {
      KLD_E.BtnExpand (branches[j]);
    }
  }
} // end of BtnExpand -----------------------------------------------------------------------------

KLD_E.AddNodeOrItem = function (oTree, indxOnLevel, lvl, bNode, sLabel, sDocName, nUnique) { // ===
//            Build the tree item (node or item) and add the properties for navigation
// Arguments  oTree          TreeView object to be handled
//            indxOnLevel    Array of current indes in level. E.g. [1.0.2.0] will refer to
//                           oTree.items[1].items[0].items[2].items[0]
//            lvl            Level of heading (0: topmost, 3 (or else) lowest
//            bNode          true for node, false for item
//            sLabel         Label for the presentation of the node/item
//            sDocName       document name for the hypertext command
//            nUnique        the unique number of the target paragraph
// Returns    Modified oTree
// Called by  KLD_E.BuildTree
// Reference  Derived from the static model in the Adobe script examples
//            and Rick Quatro DocumentNavigotor.jsx
var bNode, oTmp = oTree, indx, q;
// $.writeln(indxOnLevel + "\t" + lvl + " " + bNode + "\t" + nUnique + " " + sLabel);

  for (q = 0; q < lvl; q++) {                     // This must NOT be q <= lvl !
    indx = indxOnLevel[q];
    oTmp = oTmp.items[indx];
  }
  if (bNode) {
    oTmp.add("node", sLabel);
  } else {
    oTmp.add("item", sLabel);
  }
  if (sDocName != null) {                         // add properties for navigation
    indx = indxOnLevel[q];
    oTmp.items[indx].navName = sDocName;
    oTmp.items[indx].navUnique = nUnique;
  }
} // end of AddNodeOrItem -------------------------------------------------------------------------

KLD_E.BtnCollaps = function (oTree) { // ===- Collapse 'all' nodes in tree ========================
// Arguments  oTree          TreeView object to be handled
// Returns    Modified oTree
// Called by  KLD_E.BuildPalette
var j, branches;
  oTree.expanded = false;
  branches = oTree.items;
  for (var j = 0; j < branches.length; j++) {
    if (branches[j].type == 'node') {
      KLD_E.BtnCollaps (branches[j]);
    }
  }
} // end of BtnCollaps ----------------------------------------------------------------------------

KLD_E.BuildPalette = function (oDoc, aPgfs, sFormats, bTag) { // === Build the palette ============
// Arguments  oDoc           The document to be analysed and navigated - the current document
//            aPgfs          Array of Paragraph objects fulfilling the Title criteria
//            sFormats       Level settings (table)
//            bTag           true for presentation of tag name, false for title text
// Returns    Window wDocNav
// Called by  KLD_E.DocNav
// Calling    KLD_E.BuildTree, KLD_E.BtnCollaps, KLD_E.BtnExpand,
// Reference  Lots of experiments
var lastSlash, sRootName, oSettings = {};

  sRootName = oDoc.Name;
  lastSlash = sRootName.lastIndexOf("\\");
  sRootName = sRootName.substring(lastSlash+1);
  wDocNav = new Window ("palette", KLD_E.sDnav_title, undefined, {resizeable: true}); // Navigation de document ETB
  KLD_E.GetPalSettings (oSettings);
  wDocNav.location = [oSettings.nLeft, oSettings.nTop + 30];  // wintitle is 30 pix high
// --- top group: buttons ------------------------
  wDocNav.g1 = wDocNav.add ("group", undefined);
  wDocNav.g1.alignment = ["","top"];
  wDocNav.g1.btnExpand = wDocNav.g1.add ("button", undefined, KLD_E.sDnav_bExpand); // Développer
  wDocNav.g1.btnExpand.size = [80,20];
  wDocNav.g1.btnExpand.helpTip = KLD_E.sDnav_hlpTip2;
  wDocNav.g1.btnCollapse = wDocNav.g1.add ("button", undefined, KLD_E.sDnav_bCollapse); // Réduire
  wDocNav.g1.btnCollapse.size = [80,20];
  wDocNav.g1.btnCollapse.helpTip = KLD_E.sDnav_hlpTip3;
  wDocNav.g1.btnDefine = wDocNav.g1.add ("button", undefined, KLD_E.sDnav_bDefine); // Réduire
  wDocNav.g1.btnDefine.size = [80,20];
  wDocNav.g1.btnDefine.helpTip = KLD_E.sDnav_hlpTip7;
// --- main panel: the gree view -----------------
  wDocNav.p1 = wDocNav.add("panel", undefined, sRootName); // Root required for treeview to work
  wDocNav.p1.alignment = ["fill", "fill"];
  wDocNav.p1.alignChildren = ["fill", "fill"]

  KLD_E.oTree = wDocNav.p1.add ("treeview", undefined, "");
  KLD_E.oTree.preferredSize = [oSettings.nTwidth, oSettings.nTheight];
  KLD_E.oTree.graphics.font = ScriptUI.newFont (KLD_E.oTree.graphics.font.family,KLD_E.oTree.graphics.font.style,14);
  KLD_E.BuildTree (oDoc, KLD_E.oTree, aPgfs, sFormats, bTag);
// --- bottom group: buttons ---------------------
  wDocNav.g2 = wDocNav.add ("group", undefined);
  wDocNav.g2.alignment =  ["", "bottom"];
  wDocNav.g2.alignChildren = "fill";
//wDocNav.g2.orientation =  ["row"]; // default for group
  wDocNav.g2.btnBack = wDocNav.g2.add ("button",undefined,"<<");      // Go back button.
  wDocNav.g2.btnBack.size = [30,20];
  wDocNav.g2.btnBack.helpTip = KLD_E.sDnav_hlpTip4;
  wDocNav.g2.cb1 = wDocNav.g2.add ("checkbox", undefined, KLD_E.sDnav_cbStyle); // Style name/Title ...
  wDocNav.g2.cb1.helpTip = KLD_E.sDnav_hlpTip5;
  wDocNav.g2.cb1.value = bTag;
  wDocNav.g2.btnRefresh = wDocNav.g2.add ("button",undefined,KLD_E.sDnav_bRefresh); // Refresh Aktualisieren Actualiser
  wDocNav.g2.btnRefresh.helpTip = KLD_E.sDnav_hlpTip6;
// --- behaviour of window and controls ----------
  wDocNav.onResize = function () {
    this.layout.resize();
  }
  KLD_E.oTree.onChange = function () {
    KLD_E.Navigate (oDoc, this);
  }
  wDocNav.g1.btnExpand.onClick = function () {
    KLD_E.BtnExpand(KLD_E.oTree);
  }
  wDocNav.g1.btnCollapse.onClick = function () {
    KLD_E.BtnExpand(KLD_E.oTree);
    KLD_E.BtnCollaps(KLD_E.oTree);
    wDocNav.show();
  }
  wDocNav.g1.btnDefine.onClick = function () {
    KLD_E.BtnDefine ();
    wDocNav.show();
  }
  wDocNav.g2.cb1.onClick = function () {
    bTag = wDocNav.g2.cb1.value;
  }
  wDocNav.g2.btnBack.onClick = function () {
    oDoc.HypertextCommand ("previouslink");
  }
  wDocNav.g2.btnRefresh.onClick = function () {
    var location = this.parent.parent.bounds;
    this.parent.parent.close ();
    KLD_E.DocNav (location, bTag);
  }
// --- final actions -----------------------------
  KLD_E.BtnExpand (KLD_E.oTree)
  wDocNav.show();
  return wDocNav;                                 // required for Refresh
} // end of BuildPalette --------------------------------------------------------------------------

KLD_E.BuildTree = function (oDoc, oTree, aPgfs, sFormats, bTag) { // === Build the tree ===========
// Arguments  oDoc           The document to be analysed and navigated - the current document
//            oTree          TreeView object to be set up
//            aPgfs          Array of Paragraph objects fulfilling the Title criteria
//            sFormats       Table to find the title paragraphs
//            bTag           true for presentation of tag name, false for title text
// Returns    The set up KLD_E.oTree
// Called by  KLD_E.BuildPalette
// Calling    KLD_E.AddNodeOrItem
// Reference  Lots of experiments
var bNode, indxOnLvl=[0], lvl=0, lvlNxt, lvlOld=0, j, jMax,
    sDocname, sLabel, sTagName;

  sDocName = oDoc.Name.replace (/\\/g, "/");      // to be used in navigate
  jMax = aPgfs.length;
// --- Is structure complete?
  lvlNxt = KLD_E.GetLevel (aPgfs[0], sFormats);
  while (lvlNxt > lvl) {
    sLabel = KLD_E.sDnav_unused;             // "→ Unused level"
    KLD_E.AddNodeOrItem (oTree, indxOnLvl, lvl, true, sLabel, null, null)
    indxOnLvl.push(0);
    lvl = Number(lvl) + 1;
  }
// --- Build tree from paragraph levels ----------
  for (j = 0; j < jMax; j ++) {                   // for all extracted paragraphs
    sTagName = aPgfs[j].Name;
    unique = aPgfs[j].Unique;
    if (bTag) {
      sLabel = sTagName;
    } else {
      sLabel = KLD_E.GetText (aPgfs[j]);
      sLabel = KLD_E.CnvCtrlToSpace (sLabel);     // control chars → space
    }
    lvlOld = lvl;
    lvl = KLD_E.GetLevel (aPgfs[j], sFormats);
    lvlNxt = j+1 < jMax ? KLD_E.GetLevel (aPgfs[j+1], sFormats) : undefined // last item undefined
    bNode = lvlNxt > lvl;
    while (lvl < lvlOld) {                      // ascend from deeper level
      lvlOld -= 1;
      indxOnLvl.pop();
      indxOnLvl[lvlOld] = indxOnLvl[lvlOld] + 1;
    }
    if (bNode) {
      KLD_E.AddNodeOrItem (oTree, indxOnLvl, lvl, bNode, sLabel, sDocName, unique)
      indxOnLvl.push(0);                          // sub items counter
    } else {
      KLD_E.AddNodeOrItem (oTree, indxOnLvl, lvl, bNode, sLabel, sDocName, unique)
      indxOnLvl[lvl] = indxOnLvl[lvl] + 1;          // inc counter
    }
// --- check for irregular diving ----------------
    while (lvlNxt - lvl > 1) {
      sLabel = KLD_E.sDnav_missing;    // "→ Missing level",
      lvl = Number(lvl) + 1;
      KLD_E.AddNodeOrItem (oTree, indxOnLvl, lvl, true, sLabel, null, null)
      indxOnLvl.push(0);
    }
  }
} // end of BuildTree -----------------------------------------------------------------------------

KLD_E.Navigate = function (oDoc, oTree) { // === Perform the navigation on clik on the tree-item ==
// Arguments  oDoc           The document to be analysed and navigated - the current document
//            oTree          TreeView object to be handled
// Comment    Althoug the selection is cancelled, it still can be recognised as grey shadow (fine so)
// Called by  oTree.onChange in KLD_E.BtnCollaps
// Reference  Rick Quatro: The constant ":2" is from Hypertext marker syntax.
//            When you generate a TOC and look at the markers, you will see the 2.
//            If you generate a list of markers or a list of elements, the number is different:
//            The number depends on the type of object that you are referencing.
var unique, docName, item, cmd;
//$.bp(true);
  item = oTree.selection;
//$.writeln ("Navigate " + item.text);
  if (item) {
    navName    = item.navName;
    navUnique  = item.navUnique;
    cmd = "gotoObjectId " + navName + ":2 " + navUnique;
    oDoc.HypertextCommand (cmd);
    oTree.selection = null;
  }
} // end of Navigate ------------------------------------------------------------------------------

KLD_E.GetLevelSettings = function () {
// Arguments  sFormats       string version of the format table:
//                           0Format-a 1Format-b 1Format-c 2Format-d 3Format-e
// Comment    sFormats allows easy comparison without loop by means of IndexOf
// Called by  KLD_E.DocNav
// Calling    KLD_E.GetIniValue
var j, sCfgFile, sFormat, sFormats = "";

  sCfgFile = KLD_E.sExtrasCfg
  for (j = 0; j < 4; j++) {                     // levels 0 … 3
    sFormat = KLD_E.GetIniValue (sCfgFile, j, undefined);
    if (sFormat != undefined) {
      sFormat = sFormat.replace(/;/g, ";"+j);   // there may be mulitple format names
      sFormats = sFormats + j + sFormat + "; "  // ; only for visual aid on inspection
    }
  }
  if (sFormats == "") {
    alert (KLD_E.sDnav_lvlDefs, KLD_E.sDnav_title, true);
    return false;
  }
  KLD_E.sFormats = sFormats;
  return true;
} // end of GetLevelSettings ----------------------------------------------------------------------

KLD_E.GetPalSettings = function (oSettings) { // === Get positional setting for the palette =======
// Arguments  oSettings      Settings object
//             .nTop         pixels from top
//             .nLeft        pixels from the left
//             .nTheight     Tree height
//             .nTwidth      Tree width
// Called by  KLD_E.DocNav
// Calling    KLD_E.GetIniValue
var sCfgFile, pos;

  sCfgFile = KLD_E.sExtrasCfg
  oSettings.nTwidth  = Number(KLD_E.GetIniValue (sCfgFile, "Tree_width", 250));
  oSettings.nTheight = Number(KLD_E.GetIniValue (sCfgFile, "Tree_height", 500));

  oSettings.nTop  = Number(KLD_E.GetIniValue (sCfgFile, "DocNav_top", 10));
  oSettings.nLeft = KLD_E.GetIniValue (sCfgFile, "DocNav_left", "-x");  // + 60 for gap
  if (oSettings.nLeft.substr(0, 1) == "+") {
    pos = Number(oSettings.nLeft.substr(1));
    oSettings.nLeft = app.ScreenWidth + pos;
  } else if (oSettings.nLeft.substr(0, 1) == "-") {
    oSettings.nLeft = app.ScreenX - oSettings.nTwidth - 70; // additional framing around tree
  } else {
    oSettings.nLeft = Number(oSettings.nLeft);
  }
  if (oSettings.nTheight < 250) {
    oSettings.nTheight = app.ScreenHeight - 165;  // additional framing around tree
  }
} // end of GetPalSettings ------------------------------------------------------------------------

KLD_E.GetParagraphs = function (oDoc, aPgfs, sFormats) { // Get paragraphs according to table =====
// Arguments  oDoc           The document to be analysed and navigated - the current document
//            aPgfs          Array of Paragraph objects fulfilling the Title criteria
//            sFormats       Table to find the title paragraphs
// Returns    aPgfs
// Called by  KLD_E.BtnCollaps

var oPgf = oDoc.MainFlowInDoc.FirstTextFrameInFlow.FirstPgf;

  while (oPgf.ObjectValid ()) {
    iPos = sFormats.indexOf(oPgf.Name, 0);
    if (iPos > 0) {
      oPgf.UserString = sFormats.substr(iPos-1, 1); // level is just before format name
      aPgfs.push (oPgf);
    }
    oPgf = oPgf.NextPgfInFlow;
  }
  return;
} // end of GetParagraphs -------------------------------------------------------------------------

KLD_E.GetText = function (oText, oDoc) { // === Gets the text from the text object. ===============
// Arguments  oText          Any text object, particularly paragraphs
//            oDoc           Document containing oText
// Returns    Text string: text from oText
// Called by  KLD_E.BuildTree
// Reference  Rick Quatro
var text = "";
  if (oText.constructor.name !== "TextRange") { // Get a list of the strings in the text object or text range.
    var textItems = oText.GetText(Constants.FTI_String);
  } else {
     var textItems = oDoc.GetTextForRange(oText, Constants.FTI_String);
  }
  for (var i = 0; i < textItems.len; i += 1) { // Concatenate the strings.
    text += (textItems[i].sdata);
  }
  return text; // Return the text
} // end of GetText -------------------------------------------------------------------------------

KLD_E.GetLevel = function (oPgf) { // === Get the level from the ¶ tag name =======================
// Arguments  oPgf           Pargraph from which to get the level by property
// Returns    Title level as number (0 ... 3 or else)
// Called by  KLD_E.BuildTree
var lvl;

 lvl = oPgf.UserString;
 return Number(lvl);
} // end of GetLevel ------------------------------------------------------------------------------
