﻿/* ETBinfo.jsx ====== UTF-8 =====================================================================
              Collect and present information about current installation
Comment       Included by ETBextras.jsx
Copyleft      2017 Klaus Daube, Zürich, Switzerland, klaus@daube.ch
History       2020-01-06 v2   become sub-function in ETBextra.jsx
*/ ; // ===========================================================================================

KLD_E.CreateInfo = function (){ // === Run AHK script to get specific information =================

  KLD_E.ahkFile.execute();                        // Create items in ETBextras.cfg
  $.sleep (2000);                                 // give it 5 sconds for its work
} // --- end KLD_E.CreateInfo

KLD_E.GetInfo = function () { // === get the information from ETBextras.cfg =======================
  KLD_E.oInfo.InfoDate  = KLD_E.GetIniValue (KLD_E.sExtrasCfg, "InfoDate", undefined);       // 2019-09-23 14:36
  KLD_E.oInfo.FMhome    = KLD_E.GetIniValue (KLD_E.sExtrasCfg, "InfoFMhome", undefined);     // H:\Adobe\FrameMaker.15en\Adobe FrameMaker 2019
  KLD_E.oInfo.FMversion = KLD_E.GetIniValue (KLD_E.sExtrasCfg, "InfoFMfull", undefined);     // 15.0.4.751
  KLD_E.oInfo.FMedition = KLD_E.GetIniValue (KLD_E.sExtrasCfg, "InfoFMedition", undefined);  // 2019
  KLD_E.oInfo.FMbitty   = KLD_E.GetIniValue (KLD_E.sExtrasCfg, "InfoFMbitty", undefined);    // 64
  KLD_E.oInfo.UIlanguage= KLD_E.GetIniValue (KLD_E.sExtrasCfg, "InfoUIlanguage", undefined); // en, de, fr
  KLD_E.oInfo.OSversion = KLD_E.GetIniValue (KLD_E.sExtrasCfg, "InfoOSversion", undefined);  // Win7 64-bit
} // --- end KLD_E.GetInfo

KLD_E.PutInfo = function () { // === get the information from maker.ini ===========================
var sText = "", sText1, sText2; 

  if (KLD_E.oInfo.UIlanguage == "de") {
    sText1= "Information über diesen FrameMaker beim Start (" + KLD_E.oInfo.InfoDate + ")\n";
    sText = sText + "\nVolle FM Version: \t"     + KLD_E.oInfo.FMversion;
    sText = sText + "\nVermarktet als: \t"       + KLD_E.oInfo.FMedition;
    sText = sText + "\nUI Sprache:\t"            + KLD_E.oInfo.UIlanguage;
    sText = sText + "\nInstallationspfad:\t"     + KLD_E.oInfo.FMhome
    sText = sText + "\nFrameMaker.exe ist ein "  + KLD_E.oInfo.FMbitty + "-bit Programm";
    sText = sText + "\nBetriebssystem: \t"       + KLD_E.oInfo.OSversion;
    sText2= "\n\nIn die Zwischeablage kopieren mit Kontextmenü 'Alles auswählen'; dann mit Strg+c kopieren.";
  } else if (KLD_E.oInfo.UIlanguage == "fr") {
    sText1= "Informations sur ce FrameMaker au démarrage (" + KLD_E.oInfo.InfoDate + ")\n";
    sText = sText + "\nVersion complète de FM :\t"  + KLD_E.oInfo.FMversion;
    sText = sText + "\nCommercialisé sous : \t"     + KLD_E.oInfo.FMedition;
    sText = sText + "\nLangue de l'interface utilisateur: " + KLD_E.oInfo.UIlanguage;
    sText = sText + "\nChemin d'installation :\t"   + KLD_E.oInfo.FMhome
    sText = sText + "\nFrameMaker.exe est une "     + KLD_E.oInfo.FMbitty + "-bit application";
    sText = sText + "\nSystème d'exploitation : \t" + KLD_E.oInfo.OSversion;
    sText2= "\n\nPour copier dans le presse-papiers, utilisez le menu contextuel 'Tout sélectionner' ; puis CTRL+c pour copier.";
  } else {                                        // default is English
    sText1= "Information about this FrameMaker at start (" + KLD_E.oInfo.InfoDate + ")\n";
    sText = sText + "\nFull version of FM: \t"   + KLD_E.oInfo.FMversion;
    sText = sText + "\nMarketed as : \t"         + KLD_E.oInfo.FMedition;
    sText = sText + "\nLanguage of UI:\t"        + KLD_E.oInfo.UIlanguage;
    sText = sText + "\nInstallation path:\t"     + KLD_E.oInfo.FMhome
    sText = sText + "\nFrameMaker.exe is a "     + KLD_E.oInfo.FMbitty + "-bit application";
    sText = sText + "\nOperating system: \t"     + KLD_E.oInfo.OSversion;
    sText2= "\n\nTo copy to the clipboard use context menu 'Select all'; then CTRL+c to copy.";
  }
 KLD_E.Message ( "FMident — Information", sText1 + sText + sText2);
} // --- end KLD_E.PutInfo

KLD_E.Message = function (winTitle, msgTxt) { // === Create message dialgogue =====================
  var xLoc = $.screens[0].right / 2;
  var yLoc = $.screens[0].bottom / 3;
  var win = new Window ("dialog", winTitle) ;

  win.location = [xLoc, yLoc]; 
  win.orientation = "column";  
  win.g1 = win.add ('group {orientation: "row"}');
//win.g1.img = win.g1.add("image", undefined, "SystemInfoIcon");  // can not be found
  win.g1.info = win.g1.add("staticText", undefined, msgTxt, {multiline: true, scrolling: true});  
  win.g1.info.graphics.font = ScriptUI.newFont ("", "", 14);
  win.g1.info.preferredSize.width  = 560
  win.g1.info.preferredSize.height = 200;
  win.g2 = win.add ('group {orientation: "row"}');
  win.g2.btnOK = win.add ("button", undefined, "OK");
// Windows is created only if a button exists!
  win.g2.btnOK.onClick                = function () {
    win.close();                                  // close also with X button action
  };

  win.show();
} // --- end KLD_E.Message
